#pragma once

#include "../../../GAME_COMMON.h"
#include "../../ecs_entity.h"

#include "../component_game_object.h"
#include "../animation/component_animation_levitate.h"

typedef struct ComponentBehaviorBoomerang
{
	ECSComponent component;
	f32 angle;
	f32 speed;
	f32 initialSpeed;
	u32 timer;
	u32 timerMax;
	u32 targetID;
	bool isBoomerang;
	bool isBegin;
} ComponentBehaviorBoomerang;

void component_behavior_boomerang_init
(
	ComponentBehaviorBoomerang* self, 
	f32 initialSpeed,
	f32 speed,
	u32 timer, 
	u32 targetID
);

void component_behavior_boomerang_tick(ComponentBehaviorBoomerang* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_BEHAVIOR_BOOMERANG_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL, 
			(ECSFunction)component_behavior_boomerang_tick,
			NULL
		}
	},
	.type = ECS_COMPONENT_BEHAVIOR_BOOMERANG,
	.size = sizeof(ComponentBehaviorBoomerang)
};


