#include "entity_chip.h"

/* Initializes a chip entity. */
void
entity_chip_init(ECS* ecs, u32 id, vec3 position, u32 sender)
{
	ComponentGameObject* gameObject;

	gameObject = ecs_component_add(ecs, ECS_COMPONENT_GAME_OBJECT, id);

	component_game_object_init
	(
		gameObject,
		ecs,
		ecs->game->resources.textures[TEXTURE_CHIP],
		(f32*)CHIP_SIZE,
		(f32*)CHIP_PHYSICS_SIZE,
		position,
		CHIP_FRICTION,
		CHIP_VELOCITY_MAX,
		CHIP_GAME_OBJECT_IS_BOUNCE,
		CHIP_GAME_OBJECT_IS_AFFECTED_BY_GRAVITY,
		CHIP_GAME_OBJECT_IS_SOLID
	);
}
