#include "entity_elemental.h"

/* Initializes a elemental entity. */
void
entity_elemental_init(ECS* ecs, u32 id, vec3 position)
{
	ComponentGameObject* gameObject;

	gameObject = ecs_component_add(ecs, ECS_COMPONENT_GAME_OBJECT, id);

	ecs_component_add(ecs, ECS_COMPONENT_GOODIES, id);
	ecs_component_add(ecs, ECS_COMPONENT_FATNESS, id);

	component_game_object_atlas_init
	(
		gameObject,
		ecs,
		ecs->game->resources.textures[TEXTURE_ELEMENTAL],
		(s32*)ELEMENTAL_FRAME_SIZE,
		(s32*)ELEMENTAL_ATLAS_SIZE,
		(f32*)ELEMENTAL_SIZE,
		(f32*)ELEMENTAL_PHYSICS_SIZE,
		position,
		ELEMENTAL_FRICTION,
		ELEMENTAL_VELOCITY_MAX,
		ELEMENTAL_GAME_OBJECT_IS_BOUNCE,
		ELEMENTAL_GAME_OBJECT_IS_AFFECTED_BY_GRAVITY,
		ELEMENTAL_GAME_OBJECT_IS_SOLID
	);
}
